<script setup>
import AuthenticatedLayout from "@/Layouts/AuthenticatedLayout.vue";
import { Head } from "@inertiajs/vue3";
import { useForm } from "@inertiajs/vue3";
import InputText from "@/Components/Form/InputText.vue";
import InputSelect from "@/Components/Form/InputSelect.vue";

defineProps(["labels", "authors"]);

const form = useForm({
    name: "",
    author_id: "",
    description: "",
    image: null,
});
</script>

<template>
    <Head title="Create" />

    <AuthenticatedLayout>
        <template #header>
            <h2
                class="font-semibold text-xl text-gray-800 dark:text-gray-200 leading-tight"
            >
                Book Create
            </h2>
        </template>

        <div class="py-12">
            <div class="max-w-7xl mx-auto sm:px-6 lg:px-8">
                <div
                    class="bg-white dark:bg-gray-800 overflow-hidden shadow-sm sm:rounded-lg"
                >
                    <form
                        class="max-w-sm mx-auto my-5"
                        @submit.prevent="form.post(route('books.store'))"
                    >
                        <InputText
                            v-model="form.name"
                            :errors="form.errors.name"
                            :label="labels.name"
                        />
                        <InputSelect
                            v-model="form.author_id"
                            :items="authors"
                            class="mt-1 block w-full"
                            keyIndex="code"
                            labelIndex="Author"
                            valueIndex="id"
                        />
                        <InputText
                            v-model="form.description"
                            :errors="form.errors.description"
                            :label="labels.description"
                        />
                        <div class="mb-5">
                            <label
                                class="block mb-2 text-sm font-medium text-gray-900 dark:text-white"
                                for="image"
                                >{{ labels.image }}</label
                            >
                            <input
                                class="block w-full text-sm text-slate-500 file:mr-4 file:py-2 file:px-4 file:rounded-md file:border-0 file:text-sm file:font-semibold file:bg-violet-50 file:text-violet-700 hover:file:bg-violet-100"
                                type="file"
                                @input="form.image = $event.target.files[0]"
                            />
                            <p
                                v-if="form.errors.image"
                                class="mt-2 text-sm text-red-600 dark:text-red-500"
                            >
                                <span class="font-medium">Oops!</span>
                                {{ form.errors.image }}
                            </p>
                        </div>

                        <div>
                            <button
                                :disabled="form.processing"
                                class="inline-flex items-center px-4 py-2 bg-gray-800 dark:bg-gray-200 border border-transparent rounded-md font-semibold text-xs text-white dark:text-gray-800 uppercase tracking-widest hover:bg-gray-700 dark:hover:bg-white focus:bg-gray-700 dark:focus:bg-white active:bg-gray-900 dark:active:bg-gray-300 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2 dark:focus:ring-offset-gray-800 transition ease-in-out duration-150"
                                type="submit"
                            >
                                Save
                            </button>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </AuthenticatedLayout>
</template>
